// $Id: ResetMessage.java,v 1.2 1999/11/28 21:25:45 beca Exp $

/*
File: ResetMessage.java
Component: Server, Plugin
Date		Author		Changes
Apr 15 97	Lukasz Beca	Created
*/


package webwisdom.tango.messages;


import webwisdom.tango.messages.Message;
import webwisdom.tango.consts.Const;
import java.io.*;


/**
 * A class representing STARTED message
 * 
 *@author Lukasz Beca
 *@see Central Server - Local Demon protocol
 **/
public class ResetMessage extends Message
{
    private static final String CL="ResetMessage";

    private int SID;


  /**
   * Creates a new STARTED message
   *@param AIDparam application number
   **/
  
  public ResetMessage(int SIDparam) {
    
    SID = SIDparam;
    type = Const.RESET;
  }

  /**
   * Creates a new FINISH message, information is read from the input stream
   *@param instream  input stream
   **/


  ResetMessage(DataInputStream instream) throws IOException {
    
     
    SID = instream.readInt();
    
    type = Const.RESET;
    
  }

   /**
   * Writes FINISH message to the output stream
   *@param outstream  output stream
   **/

  void send(DataOutputStream outstream)  throws IOException{
  
    
    //System.out.println("Sending type " + Const.FINISH);
    outstream.writeInt(Const.RESET);
    //System.out.println("Sending AID " + AID);
    outstream.writeInt(SID);    
    outstream.flush();
  
  }
  
  public int getSID() {
  
    return SID;
  }

    public String toString()
    {
      return CL+"[SID="+SID+"]";
    }// toString __________________________________________________________


}// StartedMessage ////////////////////////////////////////////////////////


