/****************************************************************************
  $Id: AppletBase.java,v 1.13 1999/11/06 03:19:24 toma Exp $
****************************************************************************/


package webwisdom.tango.interfaces;


import java.applet.Applet;
import webwisdom.tango.consts.*;
import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.messages.CAppRequestEventMessage;
import webwisdom.tango.TLAgentApplet;
import webwisdom.tango.TLListener;
import webwisdom.tango.TAgent;
import webwisdom.tango.TangoException;



class AppletBaseTLListener implements TLListener
{
    private AppletBase ab;


    public AppletBaseTLListener(AppletBase apba)
    {
      ab=apba;
    }// AppletBaseTLListener ______________________________________________


    public void receive(AppEventMessage m)
    {
      AppEventMessage m2;
      if(m.getType()==Const.DATA)
      {
	byte[] b=m.getData();
	byte[] b2=new byte[b.length-1];
	System.arraycopy(b,1,b2,0,b.length-1);
	m2=new AppEventMessage(Const.DATA,b2);
      }
      else
      {
	m2=m;
      }
      ab.receive(m2);
    }// receive ___________________________________________________________



}// AppletBaseTLListener //////////////////////////////////////////////////




/**
 *@deprecated use webwisdom.tango.TAgent*/
public abstract class AppletBase extends Applet implements TLListener
{
    private static final String CL="AppletBase";


    private TLAgentApplet agent;

    private AppletBaseTLListener list;


    public void register()
    {
      //System.out.println(CL+".register()");
      try
      {
	list=new AppletBaseTLListener(this);
	agent=new TLAgentApplet(this);
	agent.setTLListener(list);
      }
      catch(TangoException e)
      {
	//System.err.println(CL+".register(): not in Tango!");
	//e.printStackTrace();
	throw(new RuntimeException(CL+": not in Tango: "+e.getMessage()));
      }

      {
	byte[] tab=new byte[1];
	tab[0]=CAConsts.ISMASTER;
	CAppRequestEventMessage mes=new CAppRequestEventMessage(tab);
	send(mes);
      }
    }// register ___________________________________________________________


    /**Sends message to other applets in session
       or to the control application (it depends on the type of message) 
       *@param m message
       *@see AppEventMessage*/
    public void send(AppEventMessage m)
    {
      AppEventMessage m2;
      if(m.getType()==Const.DATA)
      {
	byte[] b=m.getData();
	byte[] b2=new byte[1+b.length];
	b2[0]=(byte)TAgent.NONCHANNEL_CHANNELID;
	System.arraycopy(b,0,b2,1,b.length);
	m2=new AppEventMessage(Const.DATA,b2);
      }
      else
      {
	m2=m;
      }
      agent.send(m2);
    }// send _______________________________________________________________


    public void destroy()
    {
      //System.out.println(CL+".destroy()");
      if(agent!=null)
	agent.exit();
      super.destroy();
    }// destroy ____________________________________________________________


}// AppletBase /////////////////////////////////////////////////////////////

