// $Id: PasswdManager.java,v 1.8 1999/02/05 19:43:33 beca Exp $
/*
File: PasswdManager.java
Component: Server
Date		Author		Changes
Nov 30 98	Lukasz Beca	Created
*/

package webwisdom.tango.server;

 
import java.io.*;
import java.util.*;
import java.security.*;
import webwisdom.tango.test.Log;

public class PasswdManager {

//  private File passwdFile;
  
  private String passwdFilename;
  private MessageDigest md;
  
    
  public static final int NAME = 1;
  public static final int PASSWORD = 2;
  public static final int STATUS = 3;
  public static final int FULLNAME = 4;
  public static final int EMAIL = 5;   
  public static final int ENUMBER = 5;  
  
  public PasswdManager(String filename) throws IOException {

//      passwdFile = new File(filename);

      passwdFilename = filename;
      
      try { 
       
	      md = MessageDigest.getInstance("SHA");      	       	    
	      
	    } catch(Exception e) {
	    
	      e.printStackTrace(Log.err);
	    
	    } 	    	           
  }
  
  public void close() {
   
    passwdFilename = null;
    md = null;
      	
	}  			
  
  public String getPassword(String name) {
  
      String encPasswd;
            
      encPasswd = get(name, PASSWORD);
                  
      return encPasswd;
  
  }
  
  public String getStatus(String name) {
  
      String status;
            
      status = get(name, STATUS);
                  
      return status;
     
  }
  
  public String getFullName(String name) {
  
      String fullName;
            
      fullName = get(name, FULLNAME);
                  
      return fullName;
     
  }
  
  public String getEMail(String name) {
  
      String eMail;
            
      eMail = get(name, EMAIL);
                  
      return eMail;
     
  }
  
  public Hashtable getPasswordEntries() {
  
    Hashtable result;
    
    result = getEntries(PASSWORD);
      
    return result;

  }

 
  public Hashtable getStatusEntries() {
  
    Hashtable result;
    
    result = getEntries(STATUS);
      
    return result;

  }
  
  public Hashtable getFullNameEntries() {
  
    Hashtable result;
    
    result = getEntries(FULLNAME);
      
    return result;

  }


  public Hashtable getEMailEntries() {
  
    Hashtable result;
    
    result = getEntries(EMAIL);
      
    return result;

  }
      
    
  public boolean passwordOK(String name, String decPasswd) {
  
      String passwdFromFile;
      String encPasswd;            
      boolean result = false;	    
		        
      passwdFromFile = getPassword(name);
                           
      if (decPasswd == null || passwdFromFile == null) {
      
	       return false;
	
	    } 
           
      if (decPasswd.length() == 0 && passwdFromFile.length() == 0) {
      
	      result = true;
	      
      } else {
      
        encPasswd = getEncPasswd(decPasswd);
	      result = encPasswd.equals(passwdFromFile);
      
      }                   
      
      return result;      
    
  }
  
  
  public void addEntry(String name, String decPasswd, String status, String fullName, String eMail) throws IOException {
  
     String newName;   
     String oldName;
     String userName;
     File oldFile;
     File oldPasswdFile;
     FileWriter passwdFileWrite;
	   BufferedWriter bWriteFile;
	   String line, newLine;
	   int namePos, separatorPos;
	   boolean existed = false;
	   BufferedReader bufferedFile;
	   String encPasswd;
	   FileReader passwdFileRead;
	   File passwdFile;
	   
	   
     if (name == null || decPasswd == null || status == null || fullName == null || eMail == null) {
     
       return;
     
     }
	 
	         
     encPasswd = getEncPasswd(decPasswd);          
  //   userTable.put(name, encPasswd);
        
	   newName = passwdFilename;
     oldName = newName + ".tmp";
//     oldFile = new File(oldName);
//     oldFile.delete();   
   
     oldPasswdFile = new File(oldName);
     
     passwdFile = new File(passwdFilename);     
     passwdFile.renameTo(oldPasswdFile);     
    
     
     try {
     
       passwdFileRead = new FileReader(oldPasswdFile);     
       bufferedFile = new BufferedReader(passwdFileRead);     
       line = bufferedFile.readLine();
       
     } catch(FileNotFoundException e) {
          
       line = null;
       bufferedFile = null;
     }
	   	   
     passwdFile = new File(newName);            
     passwdFileWrite = new FileWriter(passwdFile);
     bWriteFile = new BufferedWriter(passwdFileWrite);
      
     newLine = name + ":" + encPasswd + ":" + status + ":" + fullName + ":" + eMail;
     		         
	 
	   while(line != null) {    		   		  


//		      separatorPos = line.indexOf(':');
//		      userName = line.substring(0, separatorPos);

		      userName = getField(line, NAME);
			    
					if (userName.equals(name) && !line.startsWith("#")) {
					   
					   existed = true;      						 
						 bWriteFile.write(newLine, 0, newLine.length());
						 bWriteFile.newLine();
						 bWriteFile.flush();
						 
					} else {
					
					  bWriteFile.write(line, 0, line.length());
					  bWriteFile.newLine();
					  bWriteFile.flush();
					  
					}
					
		      try {     
	         
		        line = bufferedFile.readLine();
       
		      } catch (Exception e) {
          
			       e.printStackTrace(Log.err);
       
		      }
                                                                            					
		}          
      
      
	  if (!existed) {	    																																			       																																																																				       
																																																																																																							       									  																	       		                                                       
			bWriteFile.write(newLine, 0, newLine.length());
			bWriteFile.newLine();
			bWriteFile.flush();																																																																																													      																																																																																																																	       																																											       																																																																																											       		   																	       																									       
		} 
		
		if (bufferedFile != null) {			
											
		  bufferedFile.close();	
		}
		
		bWriteFile.close();		
		oldPasswdFile.delete();  
								  																																																 
																																																																																					 							       																								                                                                         
  }
  
  
   public void removeEntry(String name) throws IOException {
  
     String newName;   
     String oldName;
     String userName;
     int separatorPos;
     File oldFile;
     File oldPasswdFile;
     FileWriter passwdFileWrite;
	   BufferedWriter bWriteFile;
	   String line;
	   int namePos;
//	   boolean existed = false;
	   BufferedReader bufferedFile;
	   FileReader passwdFileRead;
	   File passwdFile;
	   
     if (name == null) {
     
       return;
     
     }
	 
	         
  //   encPasswd = getEncPasswd(decPasswd);          
  //   userTable.put(name, encPasswd);
        
	   newName = passwdFilename;
     oldName = newName + ".tmp";
//     oldFile = new File(oldName);
//     oldFile.delete();   
   
   
     oldPasswdFile = new File(oldName);
     passwdFile = new File(passwdFilename);
     passwdFile.renameTo(oldPasswdFile);     
//     oldPasswdFile = new File(oldName);
     
     try {
     
       passwdFileRead = new FileReader(oldPasswdFile);     
       bufferedFile = new BufferedReader(passwdFileRead);     
       line = bufferedFile.readLine();
       
     } catch(FileNotFoundException e) {
          
       line = null;
       bufferedFile = null;
     }
	   	   
     passwdFile = new File(newName);            
     passwdFileWrite = new FileWriter(passwdFile);
     bWriteFile = new BufferedWriter(passwdFileWrite);
      
    
	 
	   while(line != null) {    		   		  

			    namePos = line.indexOf(name);
			    
			    separatorPos = line.indexOf(':');
		      userName = line.substring(0, separatorPos);
			    
					if (userName.equals(name) || line.startsWith("#")) {
					   					 					
					  bWriteFile.write(line, 0, line.length());
					  bWriteFile.newLine();
					  bWriteFile.flush();
					  
					}
					
		      try {     
	         
		        line = bufferedFile.readLine();
       
		      } catch (Exception e) {
          
			       e.printStackTrace(Log.err);
       
		      }
                                                                            					
		}    
		 
		if (bufferedFile != null) {	
			        
		  bufferedFile.close();	
	  }
	  
		bWriteFile.close();			
		oldPasswdFile.delete();											  																																																 
																																																																																					 							       																								                                                                         
  }

  
  private String getEncPasswd(String decPasswd) {           
         
     String encPasswd;
     StringBuffer tmpPasswd = new StringBuffer();
     byte[] table;
     int i;
         
     md.update(decPasswd.getBytes());                     
     table = md.digest();
     
     for (i = 0; i < table.length - 1; i ++) {
     
       tmpPasswd.append(String.valueOf(table[i]) + ".");     
     
     }
     
     tmpPasswd.append(String.valueOf(table[i]));
               
     encPasswd = tmpPasswd.toString();

     return encPasswd;
  
  }
  
  public Hashtable getEntries(int column) {
  
    String line, user, data = null;
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    Hashtable result = new Hashtable();
    File passwdFile;
  
    try { 
       
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
	      passwdFile = null;
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFile = null;
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        Log.out.println("PasswdManager: " + e, 2);
        line = null;
        System.exit(1);
      }
    

      if (line != null) {
      
	      if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){

		      
			    user = getField(line, NAME);			      			     			      
				  data = getField(line, column);				    				    
				    												    
			    if (user != null) {														    
																												    				    				    
				     if (data == null) {
				    
					     Log.out.println("PasswdManager: user has null password", 2);
						   data = new String("");
				     }
				    			    
				     result.put(user, data);
				     data = null;
				      
				  }
				  
			  }		         
			    //  System.out.println("PasswdManager: user added with parameters " + user + " " + password);
      }               	    

    } while(line != null);
        
    return result;

  }

  
  private String get(String name, int column) {
  
    String line, user, field = null; 
    FileReader passwdFileRead;      
    BufferedReader bufferedFile;
    File passwdFile;
 
    try { 
       passwdFile = new File(passwdFilename);
       passwdFileRead = new FileReader(passwdFile);      	       	    
	    		      
    } catch(FileNotFoundException e) {
	    
		    passwdFileRead = null;
	      return null;
	    
	  } catch(Exception e) {
	    
	      passwdFileRead = null;
	      e.printStackTrace(Log.err);
	      return null;
	    
	  }
 
    bufferedFile = new BufferedReader(passwdFileRead);
 
    do {
      
      try {
      
        line = bufferedFile.readLine();
	
      } catch(Exception e) {

        Log.out.println("PasswdManager: " + e, 2);
        line = null;
        System.exit(1);
      }

      if (line != null) {

        if (!line.startsWith("#") && !line.startsWith(" ") && !line.startsWith("\n")){
		     		      
			      user = getField(line, NAME);
			      
			      if (user != null) 
			      			      
				      if (user.equals(name)) {
			      
					      field = getField(line, column);
				      
				      }				    				  
				}  
	    }

    } while(line != null && field == null);
    
    
    return field;        
  
  }
  
  
  
  private String getField(String line, int column) {
  
    int start, end, pos1, pos2;
    String result = null;
    
    
    pos2 = getPosition(line, ENUMBER - 1);
    
    if (pos2 == -1) 
    
      return null;
    
    
    switch(column) {
    
      case NAME:
	      
	      start = 0;
	      pos1 = getPosition(line, column);
	      if (pos1 != -1) {
	      
		      result = line.substring(start, pos1);
	      
	      }
	      break;
      
      case ENUMBER:
      
	      pos1 = getPosition(line, column - 1);
	      end = line.length();
	      
	      if (pos1 != -1) {
	      
		      result = line.substring(pos1 + 1, end);
	      
	      }
	      break;	      
      
    
      default:
      
	      pos1 = getPosition(line, column - 1);
	      pos2 = getPosition(line, column);
	      
	      if (pos1 != -1 && pos2 != -1) {
	      
		      result = line.substring(pos1 + 1, pos2);
	      
	      }
	                  
    }
    
	
	  return result;      
      
  }
  
  private int getPosition(String line, int occurence) {
  
    int position = 0;
    int tmp = 0;
  
    while (occurence > 0 && position != -1) {
    
      position = line.indexOf(":", tmp + 1);
      tmp = position;        
      occurence --;
    }
    
    return position;
  
  }
        
}
