// $Id: License.java,v 1.2 1999/02/22 23:41:54 beca Exp $
/*
File: License.java
Component: Server
Date		Author		Changes
Feb 15 99	Lukasz Beca	Created
*/

package webwisdom.tango.server;
 
import java.io.*;
import java.util.*;
import java.security.*;
//import webwisdom.tango.test.Log;


public class License {
  
  private MessageDigest md;
  
  private int allowedUsers;
  private GregorianCalendar expirationDate;
  private int type;
  private String tangoLicense;
  private String localIP;
      
  public static final int UNLIMITED = 1;
  public static final int EVALUATION = 2;
  public static final int COMMERCIAL = 3;
  public static final int INVALID = 4;
  
  
  public License(String license, String ip){

//      passwdFile = new File(filename);
 
	  allowedUsers = -1;
	  expirationDate = null;
	  type = INVALID;
	  tangoLicense = license;
	  localIP = ip;
	  
//	  Log.out.println("tango license" + tangoLicense, 4);
	        
    try { 
       
	    md = MessageDigest.getInstance("SHA");      	       	    
	      
	  } catch(Exception e) {
	    
	    e.printStackTrace();
	    md = null;
	    
	  } 
	  
		interpretLicense();		   	    	           
  }
  
  public final GregorianCalendar getExpirationDate() {
  
    return expirationDate;
  
  }
  
  
  public final int getAllowedUsers() {
  
    return allowedUsers;
  
  }
  
  public final int getLicenseType() {
  
    return type;
  
  }
  
  public final boolean isValid() {
  
    return (!(type == INVALID));
  }
  
  
    
  private void interpretLicense() {
  
     
    if (!isUnlimitedLicense()) {
    
      if (!isEvaluationLicense()) {
      
	      if (!isCommercialLicense()) {
    
		      type = INVALID;
	      }    
	    }
	  }  
  }
  
  
  private boolean isUnlimitedLicense() {

    boolean result = false;
    
    String template = getTemplate("sldk4874jsxapqwdv984iednio398wdkfd89734kub9834ziha983");
    
//    System.out.println("unlimited check: " + template);
    
    
    if (tangoLicense.equals(template)) {
    
      type = UNLIMITED;
      result = true;
    
    }  
    
    return result;
  }
    
  
  private boolean isEvaluationLicense() {
  
    GregorianCalendar now = new GregorianCalendar();
    int month = now.get(GregorianCalendar.MONTH);
    int year = now.get(GregorianCalendar.YEAR);
    int checkMonth = month - 3;
    int usedYear = year;          
    int usedMonth = month - 3;
    int expMonth = 0;
    int expYear = 0;
    String template;
    boolean result = false;
    
    do {
      
      checkMonth ++;
      
	    if (checkMonth < 0) {
	    
	      usedYear = year - 1;	      	     	      
		    usedMonth = 12 + checkMonth;
		      		   	      	    
	    } else {
	    
	      usedYear = year;
	      usedMonth = checkMonth;
	    
	    }
	    
//	    Log.out.println("eval: " + usedMonth + " " + usedYear, 4);
       
	    template = getTemplate("eojiads9843" + usedMonth + "84kajfla983" + usedYear + "ekds9488934dtmkj" + localIP + "bds83fq");
//	    System.out.println(template);
	  		  
	  } while (!tangoLicense.equals(template) && checkMonth != month);
	  
		if (tangoLicense.equals(template)) {
    
      type = EVALUATION;
      expMonth = usedMonth + 3;
      expYear = usedYear;
      
      if (expMonth > 11) {
      
	      expMonth = expMonth - 12;
	      expYear ++;
      
      }
      
      expirationDate = new GregorianCalendar(expYear, expMonth, 1);
      
      result = true;
    
    }  
 
    return result;			          
  
  }
  
  
  private boolean isCommercialLicense() {
  
    int connections = 0;
    String template;
    boolean result = false;
    
    do {
      
      connections ++;
      template = getTemplate("qpmcls3923ka" + connections + "qwlek98cnmx" + localIP + "eiowknv2");
//      Log.out.println(template, 4);
		  
	  } while (!tangoLicense.equals(template) && connections < 100);   
    
    if (tangoLicense.equals(template)) {
    
      type = COMMERCIAL;
      allowedUsers = connections;
      result = true;
    
    } 
    
    if (result == false) {
    
      connections = 0;
    
      do {
      
	      connections ++;
	      template = getTemplate("34oieuqlsjsvb" + connections + "ewienatrqe984llad263mbxzcs");
//	      Log.out.println(template, 4);
		  
	    } while (!tangoLicense.equals(template) && connections < 100);   
    
      if (tangoLicense.equals(template)) {
    
	      type = COMMERCIAL;
	      allowedUsers = connections;
	      result = true;
    
      }             
    }
               
    return result;
  }
  
  private String getTemplate(String content) {
  
    String encPasswd;
    StringBuffer tmpPasswd = new StringBuffer();
    byte[] table;
    int i;
         
    md.update(content.getBytes());                     
    table = md.digest();
     
    for (i = 0; i < table.length - 1; i ++) {
     
       tmpPasswd.append(String.valueOf(table[i]) + ".");     
     
    }
     
    tmpPasswd.append(String.valueOf(table[i]));
               
    encPasswd = tmpPasswd.toString();

    return encPasswd;    
  
  }   
           
}

